=== debian/changelog ===
suitesparse (1:5.7.1+dfsg-2) unstable; urgency=medium

  * libatomic.patch: new patch, should fix FTBFS on armel, mipsel, m68k
    and powerpc

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 29 Feb 2020 14:16:34 +0100

suitesparse (1:5.7.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.7.1+dfsg
  * d/copyright:
    + add GraphBLAS_API_C_v13.pdf to Files-Excluded
    + reflect upstream changes
  * libsuitesparse-doc: README.txt replaced by SuiteSparse_README.md
  * Bump S-V to 4.5.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 26 Feb 2020 16:00:43 +0100
